#include <Arduino.h>
#include <TDA6508PLL.h>
#include <TUA6039PLL.h>
#include <SN761668PLL.h>
#include <PNX3000DigitalVideoProcessors.h>
#include <LiquidCrystal_I2C.h>
#include <IRremote.h>
int RECV_PIN = 5;  // IR Receiver pin
IRrecv irrecv(RECV_PIN);
decode_results results;
LiquidCrystal_I2C  lcd(0x27, 16, 2);
#define clk 4
#define dta 3
#define cnt1 6
#define cnt2 7
int cureentclock =0;
int previceClock =0;
uint16_t CBFraquency = 9800; // CB radio start fraquncy scan
uint16_t FM915Frequency = 17370; // 915 MHZ start fraquncy scan
uint16_t TVFrequency = 2090; // tv start fraquncy scan
uint16_t FMFrequency = 3000; // fm radio start fraquncy scan
byte snpllFraquency =40; //SN761668 digital pll
uint16_t FrequencyVariable=0;
uint8_t TVSelect=1;
uint8_t osci=1;
uint8_t freq=1;
uint8_t videoOutputSelect =1;
void Display(){
  TCA9548A(0);
  lcd.clear();
  lcd.setCursor(0,0);
  switch (freq)
  {
  case 1:
  lcd.print("TV:");
  break;
  case 2:
  lcd.print("FM:");
  break;
  case 3:
  lcd.print("FMV:");
  break;
  case 4:
  lcd.print("SN:");
  break;
  case 5:
  lcd.print("CB:");
  break;
  }

  lcd.setCursor(3,0);
  lcd.print(FrequencyVariable);
  lcd.setCursor(10,0);
  lcd.print("TVn:");
  switch (TVSelect)
  { 
  case 1 :
  lcd.setCursor(14,0);
   lcd.print(1);
    break;
  case 2:
  lcd.setCursor(14,0);
  lcd.print(2);
  break;
  case 3:
  lcd.setCursor(14,0);
  lcd.print(3);
  break;
 
  }
 lcd.setCursor(0,1);
 lcd.print("osci:");
 lcd.setCursor(5,1);
 lcd.print(osci);
 lcd.setCursor(9,1);
 lcd.print("vidn:");
 lcd.setCursor(14,1);
 lcd.print(videoOutputSelect);
}
void AudioSelector(int source){
  switch (source)
  {
  case 1:
    digitalWrite(cnt1,HIGH);
    digitalWrite(cnt2,LOW);
    break;
    case 2:
    digitalWrite(cnt1,HIGH);
    digitalWrite(cnt2,HIGH);
    break;
  }
}
void TVSwitch(uint8_t source,uint8_t oscil){
  switch (source)
  {
  case 1:
    TDATVtuner(FrequencyVariable,oscil);
    AudioSelector(1);
    break;
    case 2:
    TUATVtuner(FrequencyVariable,oscil);
    AudioSelector(2);
    break;
    case 3:
    SNTVTuner(FrequencyVariable,oscil);
    break;
  }
}

void setup() {
  // put your setup code here, to run once:
 Wire.begin();
Serial.begin(9600);
   irrecv.enableIRIn();
  lcd.init(); 
   lcd.begin(16,2);
  lcd.backlight();
  pinMode(clk,INPUT);
  pinMode(dta,INPUT);
  pinMode(cnt1,OUTPUT);
 pinMode(cnt2,OUTPUT);
  FrequencyVariable = TVFrequency;
  //TDApoweronreset();
  //TUApoweronreset();
  //SNpoweronreset();
 SNTVTuner(912,osci);
 MM1630videoSwitch();
  previceClock = digitalRead(clk);
  TVSwitch(TVSelect,osci);
  Display();
 
}

void loop() {
  // put your main code here, to run repeatedly:
    cureentclock = digitalRead(clk);
  
  if(cureentclock != previceClock){
   if(cureentclock != digitalRead(dta)){
    
    FrequencyVariable--;
    TVSwitch(TVSelect,osci);
    Display();
   }
   else {
    FrequencyVariable++;
    TVSwitch(TVSelect,osci);
    Display();
   }
  }
  previceClock = cureentclock;
    if(irrecv.decode(&results)){
      switch (results.value)
      {
      case 3772790473 : // red button for tv number 1
      TVSelect=1;
       TVSwitch(TVSelect,osci);
       Display();
     
      break;
     case 3772786903: // green button for tv number 2
     TVSelect=2;
      TVSwitch(TVSelect,osci);
      Display();
    
     break;
     case 3772819543: // blue button for tv number 3
     TVSelect =3;
      TVSwitch(TVSelect,osci);
      Display();
    
     break; 
     case 3772778233: // up button for oscillator switch
     osci++;
     if(osci>=6)osci=6;
      TVSwitch(TVSelect,osci);
      Display();
     break;
     case 3772810873: // down button for oscillator switch
     osci--;
     if(osci<=0)osci=1;
      TVSwitch(TVSelect,osci);
      Display();
     break;
     case 3772794553: // right button for frq select
       freq++;
       if(freq>=5)freq=5;
      if(freq ==1) FrequencyVariable =TVFrequency;
      if(freq ==2) FrequencyVariable = FMFrequency;
      if(freq == 3) FrequencyVariable = FM915Frequency; 
      if(freq ==4) FrequencyVariable = snpllFraquency;
      if(freq == 5) FrequencyVariable = CBFraquency;
      Display();
      break;
      case 3772819033: //left button for frq select
        freq--;
       if(freq<=0)freq=1;
      if(freq ==1) FrequencyVariable =TVFrequency;
      if(freq ==2) FrequencyVariable = FMFrequency;
      if(freq == 3) FrequencyVariable = FM915Frequency; 
      if(freq ==4) FrequencyVariable = snpllFraquency;
       if(freq == 5) FrequencyVariable = CBFraquency;
      Display();
      break;
      case 3772795063:  //channel up
      FrequencyVariable++;
      TVSwitch(TVSelect,osci);
      Display();
      break;
      case 3772778743: // channel down
      FrequencyVariable--;
      TVSwitch(TVSelect,osci);
      Display();
      break;
      case 3772784863: // button number one for video output one
       videoOutputSelect=1;
      videoProcessors(videoOutputSelect);
      Display();
      break;
      case 3772817503: // button number two for video output
      videoOutputSelect =2;
      videoProcessors(videoOutputSelect);
      Display();
      break;
      case 3772801183: // button three for video output three
      videoOutputSelect=3;
      videoProcessors(videoOutputSelect);
      Display();
      break;
      }
    Serial.println(results.value);
    }
    irrecv.resume();
}